# warhol 🎨🖌

###### The WARHOL Language README


```
Martina Atabong | maa2247
Charvinia Neblett | cdn2118
Samuel Nnodim | son2105
Catherine Wes | ciw2109
Sarina Xie | sx2166
```

## commands to run hello world
```
make
./warhol.native < hello.wl > hello.ll
lli hello.ll
```

## commands to link with a library
```
make
./warhol.native < ${basename}.wl > ${basename}.ll
llc ${basename}.ll > ${basename}.s
cc -o ${basename}.exe ${basename}.s ${libs}
./${basename}.exe

```

## how to push

just made a change, what do i do?

on **your branch**, do this:
```
git add .                        // add your change
git commit -m '[your message]'   // write a message
git checkout master              // switch to the 'master' branch
git merge [your branch]          // merge your changes
git push origin master           // push, so we can all have it
```

remember to switch **BACK** to your branch


## Compiler

to generate the scanner run this and type in

```
$ ocamllex scanner.mll && ocaml scanner.ml
24 states, 645 transitions, table size 2724 bytes

int main(){ print(42); }.  // type this in.

INT ID LPAREN RPAREN LBRACE ID LPAREN LITERAL RPAREN SEMI RBRACE invalid_token
```

```
// this does something else

ocamllex scanner_test.ml && ocaml scanner_test.ml \
	| menhir --interpret --interpret-show-cst parser.mly
```

## Reading Materials

http://caml.inria.fr/pub/docs/manual-ocaml/lexyacc.html

Other groups that also implement matrices:
- CMAT
- DARN
- LePIX

