type token =
  | LPAREN
  | RPAREN
  | LBRACE
  | RBRACE
  | LSQUARE
  | RSQUARE
  | COMMA
  | SEMI
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | NOT
  | AND
  | OR
  | EQ
  | NEQ
  | LT
  | LEQ
  | GT
  | GEQ
  | STAR
  | AMPERSAND
  | INT
  | VOID
  | BOOL
  | CHAR
  | INTLITERAL of (int)
  | STRINGLITERAL of (string)
  | ID of (string)
  | CHARLITERAL of (char)
  | TRUE
  | FALSE
  | IF
  | ELSE
  | NOELSE
  | WHILE
  | FOR
  | ASSIGN
  | FUN
  | RETURN
  | EOF

val program :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast.program
