#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

/*Function: Openfile
 *
 *Input: Takes in a filename with only numbers
 *Returns: The first integer in the file or -1 on empty file
 *Algorithm: after saving the first integer in file 
 *for returning to caller, openfile copies all bytes after
 *the first integer to a temp file. The temp file copies all
 *of its values to the original file. This removes the first
 *integer from the original file.
 *Note: The original file is overwitten and empty on success
 *How To Test: Look at main  
 *This logic and impleentation is cray and not efficient but works
 */        

#define PASSVALUE -2

int openfile(const char *filename)
{
  //Open userfile to read, a temp file to write
  FILE * fp, *fptemp;
  fp = fopen(filename, "r");
  fptemp = fopen("temp", "w+");

  //pixel_value is returned to warhol call function
  //c holds bytes to read and to be written
  int pixel_value, c;
  char line[1000];


  //Purpose: return then eliminate first integer
  if( fgets(line, 1000, fp) != NULL ){ 
    
    //get first integer
    char *s = strtok(line, " ,");
    pixel_value = atoi(s);
    // seek forward
    fseek( fp, strlen(s), SEEK_SET);

    // skip spaces
    while(1){  
      if(isspace(c=fgetc(fp)) || c == ','){
        // fseek(fp, 1, SEEK_CUR);
      } else {
        // fseek(fp, -1, SEEK_CUR);
        break;
      }    
    }

    // char *s = strtok(line, " ");
    // switch(*s){
    //   case 'P':
    //     pixel_value = PASSVALUE;
    //     fseek( fp, strlen(line), SEEK_SET);
    //     break;
    //   case '#':
    //     pixel_value = PASSVALUE;
    //     fseek( fp, strlen(line), SEEK_SET);
    //     break;
    //   case ' ':
    //     pixel_value = PASSVALUE;
    //     fseek( fp, strlen(s), SEEK_SET);
    //     break;
    //   default:
    //     pixel_value = atoi(s);
    //     printf("The value of this char is: %s\n", s);
    //     fseek( fp, strlen(s), SEEK_SET);
    // }


    /* WRITE BACK / COPY */

    //write all values after first to temp file
    while((c)!= EOF){
      fputc(c,fptemp);
      c=fgetc(fp);
    }

    //close user file and reopen for writing
    fclose(fp);
    FILE *fp = fopen(filename, "w+");
    fseek( fptemp, 0L, SEEK_SET);

    //write all values in temp into the oriinal file
    while((c=fgetc(fptemp))!= EOF){
      fputc(c,fp);
    }
  }
  //if the user file is empty,
  //all bytes are read or the file is already empty
  else{
    pixel_value = -1;
  }

  fclose(fp);
  fclose(fptemp);
  remove("temp");
  return pixel_value;
}

//LOOK HERE: How to test
// int main(){
//   int i;
//     while ((i=openfile("test.txt"))!= -1 ) {
//       if(i < -1){ continue; } // skip all trash values
//       printf("%d\n", i);
//       printf("---------------------\n");  
//     }
// }
